Michael Schröder
20a2742d97
OBS-URL: https://build.opensuse.org/package/show/Base:System/rpm?expand=0&rev=434
97 lines
2.9 KiB
Diff
97 lines
2.9 KiB
Diff
--- ./scripts/brp-compress.orig 2018-01-31 13:07:37.130104408 +0000
|
|
+++ ./scripts/brp-compress 2018-01-31 13:07:16.234159981 +0000
|
|
@@ -5,51 +5,78 @@ if [ -z "$RPM_BUILD_ROOT" -o "$RPM_BUILD
|
|
exit 0
|
|
fi
|
|
|
|
+LC_ALL=
|
|
+LANG=
|
|
+LC_TIME=POSIX
|
|
+
|
|
cd "$RPM_BUILD_ROOT"
|
|
|
|
# Compress man pages
|
|
COMPRESS=${COMPRESS:-gzip -9 -n}
|
|
COMPRESS_EXT=${COMPRESS_EXT:-.gz}
|
|
|
|
+check_for_hard_link()
|
|
+{
|
|
+ dir=$1
|
|
+ b=$2
|
|
+
|
|
+ inode=`ls -i $b | awk '{ print $1 }'`
|
|
+ others=`find $dir -type f -inum $inode`
|
|
+ for afile in $others ; do
|
|
+ [ "$afile" != "$b" ] && rm -f "$afile"
|
|
+ done
|
|
+
|
|
+ case $b in
|
|
+ *.Z|*.gz) gunzip $b ;;
|
|
+ *.bz2) bunzip2 $b ;;
|
|
+ *.xz|*.lzma) unxz $b ;;
|
|
+ esac
|
|
+
|
|
+ type=${b##*.}
|
|
+ for afile in $others ; do
|
|
+ [ "${afile%.$type}" != "${b%.$type}" ] && ln ${b%.$type} ${afile%.$type}
|
|
+ done
|
|
+}
|
|
+
|
|
for d in ./usr/man/man* ./usr/man/*/man* ./usr/info \
|
|
./usr/share/man/man* ./usr/share/man/*/man* ./usr/share/info \
|
|
./usr/kerberos/man ./usr/X11R6/man/man* ./usr/lib/perl5/man/man* \
|
|
./usr/share/doc/*/man/man* ./usr/lib/*/man/man* ./usr/share/fish/man/man*
|
|
do
|
|
[ -d $d ] || continue
|
|
- for f in `find $d -type f ! -name dir`
|
|
+ find $d -type f ! -name dir | while read f
|
|
do
|
|
[ -f "$f" ] || continue
|
|
|
|
case "$f" in
|
|
- *.gz|*.Z) gunzip -f $f; b=`echo $f | sed -e 's/\.\(gz\|Z\)$//'`;;
|
|
- *.bz2) bunzip2 -f $f; b=`echo $f | sed -e 's/\.bz2$//'`;;
|
|
- *.xz|*.lzma) unxz -f $f; b=`echo $f | sed -e 's/\.\(xz\|lzma\)$//'`;;
|
|
- *) b=$f;;
|
|
+ *.gz|*.Z) gunzip "$f" || check_for_hard_link $d "$f"; b=`echo $f | sed -e 's/\.\(gz\|Z\)$//'`;;
|
|
+ *.bz2) bunzip2 "$f" || check_for_hard_link $d "$f"; b=`echo $f | sed -e 's/\.bz2$//'`;;
|
|
+ *.xz|*.lzma) unxz "$f" || check_for_hard_link $d "$f"; b=`echo $f | sed -e 's/\.\(xz\|lzma\)$//'`;;
|
|
+ *) b="$f";;
|
|
esac
|
|
|
|
- $COMPRESS $b </dev/null 2>/dev/null || {
|
|
+ $COMPRESS "$b" </dev/null 2>/dev/null || {
|
|
inode=`ls -i $b | awk '{ print $1 }'`
|
|
others=`find $d -type f -inum $inode`
|
|
if [ -n "$others" ]; then
|
|
for afile in $others ; do
|
|
- [ "$afile" != "$b" ] && rm -f $afile
|
|
+ [ "$afile" != "$b" ] && rm -f "$afile"
|
|
done
|
|
- $COMPRESS -f $b
|
|
+ $COMPRESS -f "$b"
|
|
for afile in $others ; do
|
|
- [ "$afile" != "$b" ] && ln $b$COMPRESS_EXT $afile$COMPRESS_EXT
|
|
+ [ "$afile" != "$b" ] && ln "$b$COMPRESS_EXT" "$afile$COMPRESS_EXT"
|
|
done
|
|
else
|
|
- $COMPRESS -f $b
|
|
+ $COMPRESS -f "$b"
|
|
fi
|
|
}
|
|
done
|
|
|
|
- for f in `find $d -type l`
|
|
+ find $d -type l | while read f
|
|
do
|
|
- l=`ls -l $f | sed -e 's/.* -> //' -e 's/\.\(gz\|Z\|bz2\|xz\|lzma\)$//'`
|
|
- rm -f $f
|
|
- b=`echo $f | sed -e 's/\.\(gz\|Z\|bz2\|xz\|lzma\)$//'`
|
|
- ln -sf $l$COMPRESS_EXT $b$COMPRESS_EXT
|
|
+ l="`ls -l "$f" | sed -e 's/.* -> //' -e 's/\.\(gz\|Z\|bz2\|xz\|lzma\)$//'`"
|
|
+ rm -f "$f"
|
|
+ b="`echo "$f" | sed -e 's/\.\(gz\|Z\|bz2\|xz\|lzma\)$//'`"
|
|
+ ln -sf "$l$COMPRESS_EXT" "$b$COMPRESS_EXT"
|
|
done
|
|
done
|